#include "stdafx.h"
#include "_project.h"
#include <algorithm>
#include <cctype> 
#include <string>
#include "exceptions.h"

PGTypeReg::TPGTypeReg PGTypeReg::g_PGTypeReg;
PGTypeReg::TTypeReg PGTypeReg::g_TypeReg;

static bool InitReg()
{
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_BOOL), PGTypeReg::eBool));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_INT8), PGTypeReg::eInt8));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_INT4), PGTypeReg::eInt4));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_INT2), PGTypeReg::eInt2));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_FLOAT4), PGTypeReg::eFloat4));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_FLOAT8), PGTypeReg::eFloat8));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_VARCHAR), PGTypeReg::eVarchar));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_FLOAT8_ARR), PGTypeReg::eFloat8arr));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_FLOAT4_ARR), PGTypeReg::eFloat4arr));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_INT8_ARR), PGTypeReg::eInt8arr));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_INT4_ARR), PGTypeReg::eInt4arr));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_DATE), PGTypeReg::eDate));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_TIMESTAMP), PGTypeReg::eTmestamp));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_MAC_ADDR), PGTypeReg::eMACAddr));
	PGTypeReg::g_PGTypeReg.insert(std::make_pair(std::string(PG_INET), PGTypeReg::eINET));

	/*
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGbool"        ,std::string(PG_BOOL)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGint8"        ,std::string(PG_INT8)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGint4"        ,std::string(PG_INT4)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGint2"        ,std::string(PG_INT2)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGfloat4"      ,std::string(PG_FLOAT4)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGfloat8"      ,std::string(PG_FLOAT8)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGvarchar"     ,std::string(PG_VARCHAR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGvarchar"      ,std::string(PG_VARCHAR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGdate"        ,std::string(PG_DATE)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGtimestamp"   ,std::string(PG_TIMESTAMP)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGmacaddr"     ,std::string(PG_MAC_ADDR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PGinet"        ,std::string(PG_INET)));

	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_bool"        ,std::string(PG_BOOL_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_int8"        ,std::string(PG_INT8_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_int4"        ,std::string(PG_INT4_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_int2"        ,std::string(PG_INT2_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_float4"      ,std::string(PG_FLOAT4_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_float8"      ,std::string(PG_FLOAT8_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_varchar"     ,std::string(PG_VARCHAR_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_date"        ,std::string(PG_DATE_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_timestamp"   ,std::string(PG_TIMESTAMP_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_macaddr"     ,std::string(PG_MAC_ADDR_ARR)));
	PGTypeReg::g_InternalPGTypeNamesReg.insert(std::make_pair("PG_inet"        ,std::string(PG_INET_ARR)));
	*/
	
	//initializing eType
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_INT8), TypeReg::eInt8));
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_INT4), TypeReg::eInt4));
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_INT2), TypeReg::eInt2));
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_FLOAT8), TypeReg::eFloat8));
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_FLOAT4), TypeReg::eFloat4));
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_STDSTRING), TypeReg::eString));
	PGTypeReg::g_TypeReg.insert(std::make_pair(std::string(_CONSTCHARSTR), TypeReg::eConstCharStr));


	return true;
};
static const bool _init_ = InitReg();

namespace PGTypeReg
{

	extern ePGTypes getPGTypeByStr(const std::string& strType)
	{
		TPGTypeReg::iterator i = PGTypeReg::g_PGTypeReg.find(strType);
		if (i == g_PGTypeReg.end())
		{
			return PGTypeReg::eUnknownType;
		}
		return (*i).second;
	}
	extern TypeReg::eTypes getTypeByStr(const std::string& strType) 
	{
		TTypeReg::iterator i = g_TypeReg.find(strType);
		if (i == g_TypeReg.end())
		{
			return TypeReg::eUnknownType;
		}
		return (*i).second;
	};
}

extern const char PG_BOOL[]			= "%bool";
extern const char PG_INT2[]			= "%int2";
extern const char PG_INT4[]			= "%int4";
extern const char PG_INT8[]			= "%int8";
extern const char PG_FLOAT4[]		= "%float4";
extern const char PG_FLOAT8[]		= "%float8";
extern const char PG_VARCHAR[]		= "%varchar";
extern const char PG_DATE[]			= "%date";
extern const char PG_TIMESTAMP[]	= "%timestamp";
extern const char PG_INTERVAL[]		= "%interval";
extern const char PG_MAC_ADDR[]		= "%macaddr";
extern const char PG_INET[]			= "%inet";
extern const char PG_NULL[]			= "%null";

extern const char PG_BOOL_ARR[]		= "%bool[]";
extern const char PG_INT2_ARR[]		= "%int2[]";
extern const char PG_INT4_ARR[]		= "%int4[]";
extern const char PG_INT8_ARR[]		= "%int8[]";
extern const char PG_FLOAT4_ARR[]	= "%float4[]";
extern const char PG_FLOAT8_ARR[]	= "%float8[]";
extern const char PG_VARCHAR_ARR[]	= "%varchar[]";
extern const char PG_DATE_ARR[]		= "%date[]";
extern const char PG_TIMESTAMP_ARR[]= "%timestamp[]";
extern const char PG_INTERVAL_ARR[]	= "%interval[]";
extern const char PG_MAC_ADDR_ARR[]	= "%macaddr[]";
extern const char PG_INET_ARR[]		= "%inet[]";

extern const char PG_BOOL_VEC[]		= "%bool[]";
extern const char PG_INT2_VEC[]		= "%int2[]";
extern const char PG_INT4_VEC[]		= "%int4[]";
extern const char PG_INT8_VEC[]		= "%int8[]";
extern const char PG_FLOAT4_VEC[]	= "%float4[]";
extern const char PG_FLOAT8_VEC[]	= "%float8[]";
extern const char PG_VARCHAR_VEC[]	= "%varchar[]";
extern const char PG_DATE_VEC[]		= "%date[]";
extern const char PG_TIMESTAMP_VEC[]= "%timestamp[]";
extern const char PG_MAC_ADDR_VEC[]	= "%macaddr[]";
extern const char PG_INET_VEC[]		= "%inet[]";


//POD types
extern const char _INT8[]			= "__int64";
extern const char _INT4[]			= "int";
extern const char _INT2[]			= "short";
extern const char _FLOAT4[]			= "float";
extern const char _FLOAT8[]			= "double";
extern const char _STDSTRING[]		= "class std::basic_string<char,struct std::char_traits<char>,class std::allocator<char> >";
extern const char _CONSTCHARSTR[]	= "char const *";
namespace StringUtils
{
	//String useful functions
	extern void trim_right(std::string &source, const std::string &t)
	{
		source.erase(source.find_last_not_of(t) + 1);
	}
	extern void trim_left(std::string &source, const std::string &t) 
	{
		source.erase(0, source.find_first_not_of(t));
	}
	extern void tokenizeStr(const std::string& str, std::vector<std::string>& tokens, const std::string& delim)
	{
		// Skip delimiters at beginning.
		std::string::size_type lastPos = str.find_first_not_of(delim, 0);
		// Find first "non-delimiter".
		std::string::size_type pos = str.find_first_of(delim, lastPos);

		while(std::string::npos != pos || std::string::npos != lastPos)
		{
			// Found a token, add it to the vector.
			std::string res = str.substr(lastPos, pos - lastPos);
			trim_right(res);
			trim_left(res);
			tokens.push_back(res);
			// Skip delimiters.  Note the "not_of"
			lastPos = str.find_first_not_of(delim, pos);
			// Find next "non-delimiter"
			pos = str.find_first_of(delim, lastPos);
		}
	};
	extern void toLower(std::string& str)
	{
		std::transform(str.begin(), str.end(), str.begin(),	(int(*)(int)) std::tolower);
	}
	extern void toUpper(std::string& str)
	{
		std::transform(str.begin(), str.end(), str.begin(),	(int(*)(int)) std::toupper);
	}
	const bool ci_equal(const char ch1, const char ch2)
	{
		return std::toupper(ch1) == std::toupper(ch2);
	}
	const size_t ci_find(const std::string& str1, const std::string& str2)
	{
		std::string::const_iterator pos = std::search(str1.begin (), str1.end(), str2.begin(), str2.end(), ci_equal);
		if (pos == str1.end())
			return std::string::npos;
		else
			return pos - str1.begin();
	}
	char toIdentAllowedChar(char ch1)
	{
		return (ch1 == '.' || ch1 == ':') ? '_' : ch1;
	}
	extern const void transformStringDate(std::string& str)
	{
		std::transform(str.begin(), str.end(), str.begin(), boost::bind(&toIdentAllowedChar, _1));
	}
	using namespace PGTypeReg;
};
namespace DateTimeUtils
{
	extern std::string currentDate(void)
	{
		std::time_t tt = std::time(0);
		std::tm ttm = *std::localtime(&tt);
		std::stringstream s;
		s << ttm.tm_year + 1900 << "-" << ttm.tm_mon + 1 << "-" << ttm.tm_mday;
		return s.str();
	}

};
namespace LibPQExp
{	
	PG_LIBPQTYPES_API char* _PQerrorMessage(const PGconn *conn)
	{
		return PQerrorMessage(conn);
	};
	PG_LIBPQTYPES_API void _PQclear(PGresult *res)
	{
		PQclear(res);
	};
	PG_LIBPQTYPES_API char* _PQresultErrorMessage(const PGresult *res)
	{
		return PQresultErrorMessage(res);
	};
	PG_LIBPQTYPES_API ExecStatusType _PQresultStatus(const PGresult *res)
	{
		return PQresultStatus(res);
	};
	PG_LIBPQTYPES_API int _PQntuples(const PGresult *res)
	{
		return PQntuples(res);
	};
	PG_LIBPQTYPES_API int _PQnfields(const PGresult *res)
	{
		return PQnfields(res);
	};
	PG_LIBPQTYPES_API PGresult* _PQprepare(PGconn *conn, const char *stmtName, const char *query, int nParams, const Oid *paramTypes)
	{
		return PQprepare(conn, stmtName, query, nParams, paramTypes);
	};
	PG_LIBPQTYPES_API int _PQgetisnull(const PGresult *res, int tup_num, int field_num)
	{
		return PQgetisnull(res, tup_num, field_num);
	}
	PG_LIBPQTYPES_API int _PQtypesRegister(PGconn* conn)
	{
		return pqtypesimport::PQtypesRegister(conn);
	}
	PG_LIBPQTYPES_API char* _PQgetErrorField(int fieldcode)
	{
		return pqtypesimport::PQgetErrorField(fieldcode);
	}
	PG_LIBPQTYPES_API size_t _PQescapeStringConn(PGconn *conn,	char *to, const char *from, size_t length, int *error)
	{
		return PQescapeStringConn(conn, to, from, length, error);
	};
}
