#ifndef _PROJECT_H
#define _PROJECT_H

#include "PG_LibPQTypes.h"

#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/io.hpp>
#include "MultiArray.h"

#include "pqtypesimport.h"

// Memory align for structures
#define MEM_ALIGN 8
//#define _TRACE_FUNCTOR_GET
//#define _TRACE_FUNCTOR_SET

//namespace libpqtypes {
	//#include "libpqtypes.h"
//todo include only supported types
//}

/*class PgBool
{
	PgBool &operator=(const libpqtypes::PGbool &rval)
	{
		val = rval;
		return this*;
	}
	libpqtypes::PGbool &operator libpqtypes::PGbool()
	{
		return val;
	}
	libpqtypes::PGbool val;
}*/
/*
		eInt8,
		eInt4,
		eInt2,
		eFloat8,
		eFloat4,
		eVarchar,
		eFloat8arr,
		eFloat4arr,
		eInt8arr,
		eInt4arr,
		eDate,
		eTmestamp,
		eMACAddr,
		eINET
		*/
namespace fusion = boost::fusion;

struct PGvarcharContainer : public std::string
{
	
	PGvarcharContainer() {};
	template<class T>
	PGvarcharContainer(const T &s) : std::string(s) {};
	operator char *() const
	{
		return const_cast<char*>(std::string::c_str());
	}
private:
	const char *c_str() { ; }
};
typedef multi_array<PGbool>	    PG_bool;
typedef multi_array<PGint2>	    PG_int2;
typedef multi_array<PGint4>	    PG_int4;
typedef multi_array<PGint8>	    PG_int8;
typedef multi_array<PGfloat4>   PG_float4;
typedef multi_array<PGfloat8>   PG_float8;
typedef multi_array<std::string> PG_varchar;
typedef multi_array<PGdate>     PG_date;
typedef multi_array<PGtimestamp>PG_timestamp;
typedef multi_array<PGinterval> PG_interval;
typedef multi_array<PGmacaddr>  PG_macaddr;
typedef multi_array<PGinet>	    PG_inet;

typedef void PGvoid;

template <class T>
class nullify 
{
public:
	T operator()(T& elem) 
	{
		elem.reset();
		return elem;
	}
};
template <class T>
class clearVector 
{
public:
	void operator()(T& elem) 
	{
		delete elem;
	}
};

template<const char *str>
struct string_
{
	string_() : string(str) {}
	const char *string;
};
template<const char* FType, const char* FName, class MF>
struct m_func
{
	template <class Seq>				
	struct result						
	{									
		typedef void type;				
	};			
	typedef typename string_<FType> FieldType;
	typedef typename string_<FName> FieldName;
	typedef typename MF FnType;
	m_func(const FnType f) : pointer(f) {};
	FnType pointer;
	FieldType tname;
	FieldName name;
};
struct UBLASCaller
{	
	template<class T, template<class> class UBLASContainer>
	void resize(UBLASContainer<T> *c, int row, int col){};
	
	template<class T>
	void resize(boost::numeric::ublas::vector<T> *c, int row, int col)
	{
		c->resize(row, true);
	}
	template<class T>
	void resize(boost::numeric::ublas::matrix<T> *c, int row, int col)
	{
		c->resize(row, col, true);
	}

	template<class T, template<class> class UBLASContainer>
	void set(UBLASContainer<T> *c, int row, int col, T &val){};
	
	template<class T, class T1>
	void set(boost::numeric::ublas::vector<T> *c, int row, int col, T1 &val)
	{
		(*c)(row) = val;
	}
	template<class T, class T1>
	void set(boost::numeric::ublas::matrix<T> *c, int row, int col, T1 &val)
	{
		(*c)(row, col) = val;
	}

	template<class T, template<class> class UBLASContainer>
	void get(UBLASContainer<T> *c, int row, int col, T &val);
	
	template<class T, class T1>
	void get(boost::numeric::ublas::vector<T> *c, int row, int col, T1 &val)
	{
		val = *((T1*)((void*)(&(*c)(row))));
	}
	template<class T, class T1>
	void get(boost::numeric::ublas::matrix<T> *c, int row, int col, T1 &val)
	{
		val = *((T1*)(void*)(&(*c)(row, col)));
	}

	template<class T, template<class> class UBLASContainer>
	size_t size1(UBLASContainer<T> *c){ return 0; };

	 template<class T>
	size_t size1(boost::numeric::ublas::matrix<T> *c)
	{
		return c->size1();
	}
	template<class T>
	size_t size1(boost::numeric::ublas::vector<T> *c)
	{
		return c->size();
	}

	template<class T, template<class> class UBLASContainer>
	size_t size2(UBLASContainer<T> *c){ return 0; };
	
	template<class T>
	size_t size2(boost::numeric::ublas::matrix<T> *c)
	{
		return c->size2();
	}
	template<class T>
	size_t size2(boost::numeric::ublas::vector<T> *c)
	{
		return 0;
	}
	template<class T, template<class> class UBLASContainer>
	size_t getDims(UBLASContainer<T> *c) const { return 0; };

	template<class T>
	size_t getDims(boost::numeric::ublas::vector<T> *c) const
	{
		return 1;
	}
	template<class T>
	size_t getDims(boost::numeric::ublas::matrix<T> *c) const
	{
		return 2;
	}

	
	
};
template<class O>
struct functor_get
{										
	typedef typename O OwnDataType;				
	functor_get(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef OwnDataType type;			
	};	
	void operator()() const {;}
	template<typename T>				
	OwnDataType operator()(T const& t) const
	{									
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_get operator()(%1%)")%t) << std::endl;
#endif
		return (*pOwn);				
	}
	//sturb for array types
	void operator()(int& rows, int& cols) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T& val) const {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyInet&) const {;};
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyMacaddr&) const {;};
	size_t getDims() const { return 0; }
private:								
	OwnDataType* pOwn;					
};

template<class O>					
struct functor_set
{										
	typedef typename O OwnDataType;				
	functor_set(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef OwnDataType* type;			
	};	
	void operator()() const {;}
	template<typename T>				
	OwnDataType* operator()(T const& t)
	{	
#ifdef _TRACE_FUNCTOR_SET
		std::cout << boost::str(boost::format("functor_set operator()(%1%)")%t) << std::endl;
#endif
		return pOwn;				
	}
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val) {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag) const {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag, int) const {;}
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyMacaddr){;}
private:								
	OwnDataType* pOwn;					
};

template<class O, class R>
struct functor_arr_get
{										
	typedef typename O OwnDataType;				
	typedef typename R ResultType;		
	functor_arr_get(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef ResultType type;				
	};			
	void operator()() const {;}
	template<typename T>				
	ResultType operator()(T const& t) const 
	{
		return dummy_;
	}
	void operator()(int& rows, int& cols) const
	{		
#ifdef _TRACE_FUNCTOR_
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%pOwn.size1()%pOwn.size2()) << std::endl;
#endif	//size1 - number of rows, size2 - of cols
		rows = UBLASCaller().size1(pOwn); 
		cols = UBLASCaller().size2(pOwn);
	}
	template<typename T>
	void operator()(int const& row, int const& col, T& val) const
	{		
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%row%col) << std::endl;
#endif
		UBLASCaller().get(pOwn, row, col, val);
		//val = *((T*)((void*)(&(*pOwn)(row, col))));
	}
	template<class M>
	ResultType operator()(M *matrix) const
	{
		*matrix =*pOwn;
		return dummy_;
	}
	template<>
	ResultType operator()(PGmacaddr *matrix) const
	{
		//*matrix =*pOwn;
		return dummy_;
	}
	void operator()(int row, int col, ResultType val, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyInet&) const {;};
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyMacaddr&) const {;};
	size_t getDims() const { return UBLASCaller().getDims(pOwn); }
private:								
	OwnDataType* pOwn;
	ResultType dummy_;
	functor_arr_get() {;}
};

template<class O, class R>
struct functor_arr_inet_get
{										
	typedef typename O OwnDataType;				
	typedef typename R ResultType;		
	functor_arr_inet_get(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef ResultType type;				
	};			
	void operator()() const {;}
	template<typename T>				
	ResultType operator()(T const& t) const 
	{
		return dummy_;
	}
	size_t getDims() const { return UBLASCaller().getDims(pOwn); }
	void operator()(int& rows, int& cols) const
	{		
#ifdef _TRACE_FUNCTOR_
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%pOwn.size1()%pOwn.size2()) << std::endl;
#endif	//size1 - number of rows, size2 - of cols
		
		rows = UBLASCaller().size1(pOwn);
		cols = UBLASCaller().size2(pOwn);
	}
	template<typename T>
	void operator()(int const& row, int const& col, T& val) const
	{		
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%row%col) << std::endl;
#endif
		//todo check where it is called
		//val = (*pOwn)(row, col);
	}
	
	void operator()(int const& row, int const& col, ResultType &val, NullDummyInet&) const
	{		
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%row%col) << std::endl;
#endif
		//todo check where it is called
		UBLASCaller().get(pOwn, row, col, val);
	}

	void operator()(int const& row, int const& col, ResultType& val, int)
	{		
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%row%col) << std::endl;
#endif
		//todo check where it is called
		UBLASCaller().get(pOwn, row, col, val);
	}

	template<class M>
	ResultType operator()(M *matrix) const
	{
		*matrix =*pOwn;
		return dummy_;
	}
	template<>
	ResultType operator()(PGmacaddr *matrix) const
	{
		//*matrix =*pOwn;
		return dummy_;
	}
	template<class T1>
	void operator()(int row, int col, T1 val, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyMacaddr&) const {;};
private:								
	OwnDataType* pOwn;
	ResultType dummy_;
	functor_arr_inet_get() {;}
};

template<class O, class R>
struct functor_arr_macaddr_get
{										
	typedef typename O OwnDataType;				
	typedef typename R ResultType;		
	functor_arr_macaddr_get(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef ResultType type;				
	};			
	void operator()() const {;}
	template<typename T>				
	ResultType operator()(T const& t) const 
	{
		return dummy_;
	}
	void operator()(int& rows, int& cols) const
	{		
#ifdef _TRACE_FUNCTOR_
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%pOwn.size1()%pOwn.size2()) << std::endl;
#endif	//size1 - number of rows, size2 - of cols
		rows = UBLASCaller().size1(pOwn); 
		cols = UBLASCaller().size2(pOwn);
	}
	template<typename T>
	void operator()(int const& row, int const& col, T& val) const
	{		
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%row%col) << std::endl;
#endif
		//todo check where it is called
		//val = (*pOwn)(row, col);
	}

void operator()(int const& row, int const& col, ResultType& val, NullDummyMacaddr&)
	{		
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_arr_get operator()(%1%, %2%)")%row%col) << std::endl;
#endif
		//todo check where it is called
		UBLASCaller().get(pOwn, row, col, val);
	}

	template<class M>
	ResultType operator()(M *matrix) const
	{
		*matrix =*pOwn;
		return dummy_;
	}
	template<>
	ResultType operator()(PGmacaddr *matrix) const
	{
		//*matrix =*pOwn;
		return dummy_;
	}
	template<class T1>
	void operator()(int row, int col, T1 val, bool flag) const {;}
	template<class T1>
	void operator()(int const& row, int const& col, T1 &val, NullDummyInet&) const {;};
	size_t getDims() const { return UBLASCaller().getDims(pOwn); }
private:								
	OwnDataType* pOwn;
	ResultType dummy_;
	functor_arr_macaddr_get() {;}
};
template<class O, class R>
struct functor_arr_set
{										
	typedef typename O OwnDataType;				
	typedef typename R ResultType;
	functor_arr_set(OwnDataType* p) : pOwn(p) {;}
	template <class Seq>				
	struct result
	{									
		typedef ResultType* type;
	};									
	void operator()() const {;}
	template<class T>
	ResultType* operator()(const T&) const
	{
		return dummy;
	}
	template<class T>
	ResultType* operator()(T *matrix) const
	{
		*pOwn = *matrix;
		return dummy;
	}
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val) {;}
	/*void operator()(int row, int col, int val, bool flag)
	{
		if(flag)
		{
			pOwn->resize(row, col, true);
			//std::cout << "resize" << std::endl;
		}
		else
		{
			void *voidVal = &val;
			(*pOwn)(row, col) = *((ResultType*)voidVal);
		}
	}*/
	template<class T>
	void operator()(int row, int col, T val, bool flag)
	{
		if(flag)
		{
			UBLASCaller().resize(pOwn, row, col);

			//pOwn->resize(row, col, true);
			//std::cout << "resize" << std::endl;
		}
		else
		{
			void *voidVal = &val;
			UBLASCaller().set(pOwn, row, col, *((ResultType*)voidVal));
		}
#ifdef _TRACE_FUNCTOR_SET
		std::cout << boost::str(boost::format("functor_arr_set void operator()(%1%, %2%, %3%, %4%)")%row%col%val%flag) << std::endl;
		std::cout << *pOwn << std::endl;
#endif
	}
	template <class T>
	void operator()(int row, int col, T& t, bool flag, int){;}
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyMacaddr){;}
private:								
	ResultType* dummy;
	OwnDataType* pOwn;					
};
template<class O, class R>
struct functor_arr_inet_set
{										
	typedef typename O OwnDataType;
	typedef typename R ResultType;
	functor_arr_inet_set(OwnDataType* p) : pOwn(p) {;}
	template <class Seq>				
	struct result
	{									
		typedef ResultType* type;
	};									
	void operator()() const {;}
	template<class T>
	ResultType* operator()(const T&) const
	{
		return dummy;
	}
	template<class M>
	ResultType* operator()(M *matrix) const
	{
		*pOwn = *matrix;
		return dummy;
	}
	template<>
	ResultType* operator()(PGmacaddr *matrix) const
	{
		//*pOwn = *matrix;
		return dummy;
	}
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val) {;}

	template<class T1>
	void operator()(int row, int col, T1 val, bool flag) const {
		if(flag)
		{
			UBLASCaller().resize(pOwn, row, col);
			//std::cout << "resize" << std::endl;
		}
	}
	
	void operator()(int row, int col, ResultType val, bool flag, int dummyPar)
	{
		if(flag)
		{
			UBLASCaller().resize(pOwn, row, col);
			//std::cout << "resize" << std::endl;
		}
		else
			UBLASCaller().set(pOwn, row, col, val);
	}
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyMacaddr){;}
	
private:								
	ResultType* dummy;
	OwnDataType* pOwn;					
};

template<class O, class R>
struct functor_arr_macaddr_set
{										
	typedef typename O OwnDataType;
	typedef typename R ResultType;
	functor_arr_macaddr_set(OwnDataType* p) : pOwn(p) {;}
	template <class Seq>				
	struct result
	{									
		typedef ResultType* type;
	};									
	void operator()() const {;}
	template<class T>
	ResultType* operator()(const T&) const
	{
		return dummy;
	}
	template<class M>
	ResultType* operator()(M *matrix) const
	{
		*pOwn = *matrix;
		return dummy;
	}
	template<>
	ResultType* operator()(PGmacaddr *matrix) const
	{
		//*pOwn = *matrix;
		return dummy;
	}
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val) {;}

	template<class T1>
	void operator()(int row, int col, T1 val, bool flag) const {
		if(flag)
		{
			UBLASCaller().resize(pOwn, row, col);
			//pOwn->resize(row, col, true);
			//std::cout << "resize" << std::endl;
		}
	}

	void operator()(int row, int col, ResultType val, bool flag, int, NullDummyMacaddr)
	{
		if(flag)
		{
			UBLASCaller().resize(pOwn, row, col);
			//std::cout << "resize" << std::endl;
		}
		else
			UBLASCaller().set(pOwn, row, col, val);
	}
	template<class T>
	void operator()(int row, int col, T val, bool flag, int dummyPar) {;};
private:								
	ResultType* dummy;
	OwnDataType* pOwn;					
};
template <class T>
struct functor_var_set_util{
	functor_var_set_util(T *tt) : t(tt) {};
	template <class T>
	void operator=(T &t1) 
	{
		t->operator=(t1);
	}
	T& operator*()
	{
		return *t;
	}
	operator char**()
	{
		return NULL;
	}
	T *t;
};

template<class O, class R>
struct functor_var_set
{										
	typedef typename O OwnDataType;				
	typedef typename R ResultType;
	functor_var_set(OwnDataType* p) : pOwn(p) {;}
	template <class Seq>				
	struct result
	{									
		typedef ResultType* type;
	};									
	void operator()() const {;}
	functor_var_set_util<OwnDataType>& operator()(const int t)
	{
		return pOwn;
	}
	void operator()(int row, int col, ResultType val)
	{
		pOwn = val;
#ifdef _TRACE_FUNCTOR_SET
		std::cout << boost::str(boost::format("functor_var_set void operator()(%1%)")%val) << std::endl;
		std::cout << *pOwn << std::endl;
#endif
	}			
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val, bool flag) {;}			
	template <class T>
	void operator()(int row, int col, T& t, bool flag, int) const {;}
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyMacaddr){;}
private:								
	ResultType* dummy;
	functor_var_set_util<OwnDataType> pOwn;
};

template<class O, class R>
struct functor_var_get
{										
	typedef typename O OwnDataType;				
	typedef typename R ResultType;
	functor_var_get(OwnDataType* p) : pOwn(p) {;}
	template <class Seq>				
	struct result
	{									
		typedef ResultType type;
	};									
	void operator()() const {;}
	template<typename T>				
	ResultType operator()(T const& t) const
	{
		return (ResultType)pOwn->c_str();
	}
	void operator()(int& rows, int& cols) const	{;}
	template<typename T>
	void operator()(int const& row, int const& col, T& val) const {;}
	void operator()(int row, int col, ResultType val, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyInet&) const {;};
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyMacaddr&) const {;};
	size_t getDims() const { return 0; }
private:								
	ResultType* dummy;
	OwnDataType* pOwn;					
};

template<class O>
struct functor_time_get
{										
	typedef typename O OwnDataType;				
	functor_time_get(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef OwnDataType* type;			
	};	
	void operator()() const {;}
	template<typename T>				
	OwnDataType* operator()(T const& t) const
	{									
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functor_time_get operator()(%1%)")%t) << std::endl;
#endif	//for NULL supporting
		OwnDataType timest;
		memset(&timest, 0, sizeof(OwnDataType));
		return (memcmp(&timest, pOwn, sizeof(OwnDataType)) == 0) ? NULL : pOwn;
	}
	//sturb for array types
	void operator()(int& rows, int& cols) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T& val) const {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, int) const {;};
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyInet&) const {;};
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyMacaddr&) const {;};
	size_t getDims() const { return 0; }
private:								
	OwnDataType* pOwn;					
};

template<class O>					
struct functor_time_set
{										
	typedef typename O OwnDataType;				
	functor_time_set(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef OwnDataType* type;			
	};	
	void operator()() const {;}
	template<typename T>				
	OwnDataType* operator()(T const& t)
	{	
#ifdef _TRACE_FUNCTOR_SET
		std::cout << boost::str(boost::format("functor_time_set operator()(%1%)")%t) << std::endl;
#endif
		return pOwn;				
	}
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val) {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, bool, int) const {;};
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyInet&){;}
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyMacaddr){;}
private:								
	OwnDataType* pOwn;					
};

template<class O>
struct functor_lan_type_get
{										
	typedef typename O OwnDataType;				
	functor_lan_type_get(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef OwnDataType* type;			
	};	
	void operator()() const {;}
	template<typename T>				
	OwnDataType* operator()(T const& t) const
	{									
#ifdef _TRACE_FUNCTOR_GET
		std::cout << boost::str(boost::format("functo_macaddr_get operator()(%1%)")%t) << std::endl;
#endif	//for NULL supporting
		T mac;
		return (memcmp(&mac, pOwn, sizeof(T)) == 0) ? NULL : pOwn;
	}
	template<class M>
	void operator()(M *macaddr) const
	{
		*macaddr =*pOwn;
	}
	//sturb for array types
	void operator()(int& rows, int& cols) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T& val) const {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag) const {;}
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyInet&) const {;};
	template <class T>
	void operator()(int const& row, int const& col, T &val, NullDummyMacaddr&) const {;};
	size_t getDims() const { return 0; }
private:								
	OwnDataType* pOwn;					
};

template<class O>					
struct functor_lan_type_set
{										
	typedef typename O OwnDataType;				
	functor_lan_type_set(OwnDataType* p) : pOwn(p) {;}	
	template <class Seq>				
	struct result						
	{									
		typedef OwnDataType* type;			
	};	
	void operator()() const {;}
	template<typename T>				
	OwnDataType* operator()(T const& t) const
	{	
#ifdef _TRACE_FUNCTOR_SET
		std::cout << boost::str(boost::format("functo_macaddr_set operator()(%1%)")%t) << std::endl;
#endif
		return pOwn;				
	}
	template<class M>
	void operator()(M *macaddr) const
	{
		*pOwn = *macaddr;
	}
	template <typename Arg1>
	void operator()(int row, int col, Arg1 val) {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag) const {;}
	template <class T>
	void operator()(int row, int col, T& t, bool flag, int) const {;}
	template <class T>
	void operator()(int row, int col, T val, bool flag, int, NullDummyMacaddr){;}

private:								
	OwnDataType* pOwn;		
};

#endif
