#pragma once

#include "stdafx.h"
#include <iostream>
#include <vector>
#include <list>
#include <iostream>

#include <string>

#include <boost/preprocessor.hpp>
#include <boost/fusion/adapted/struct/adapt_struct.hpp>
#include <boost/fusion/algorithm/iteration/for_each.hpp>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/shared_ptr.hpp>

//#include "MultiArray.h"

#include "smartpqtypesutils.h"

/*
typedef char PGchar;
typedef int PGbool;
typedef short PGint2;
typedef int PGint4;
typedef float PGfloat4;
typedef double PGfloat8;
typedef char *PGnumeric;
typedef std::string PGvarchar;
*/

#define DEFINE_STRUCT(name, fields)          \
    DEFINE_STRUCT_I(name,                    \
        BOOST_PP_CAT(DEFINE_STRUCT_X fields, 0))

#define DEFINE_STRUCT_X(x, y) ((x, y)) DEFINE_STRUCT_Y
#define DEFINE_STRUCT_Y(x, y) ((x, y)) DEFINE_STRUCT_X
#define DEFINE_STRUCT_X0
#define DEFINE_STRUCT_Y0

#define MACRO(r, data, i, elem) \
BOOST_PP_CAT(BOOST_PP_CAT(fuctor_,data)<BOOST_PP_TUPLE_ELEM(2, 0, elem)*> BOOST_PP_CAT(data,_),BOOST_PP_TUPLE_ELEM(2, 1, elem));

#define CONS(r, data, i, elem) \
	BOOST_PP_CAT(BOOST_PP_CAT(data, _),BOOST_PP_TUPLE_ELEM(2, 1, elem))(BOOST_PP_TUPLE_ELEM(2, 1, elem)),

#define INITMEMB(r, data, i, elem) \
	BOOST_PP_TUPLE_ELEM(2, 1, elem)(NULL),

#define STRINGIFY(x) #x
//toto optimize
#define INSERTTYPE(r, data, i, elem)\
	tmp = TOSTRING(BOOST_PP_TUPLE_ELEM(2, 0, elem)); \
	colTypes_.push_back("%");\
	if (*(tmp + 2) == '_')\
	{\
		colTypes_.back() += tmp + 3;\
		colTypes_.back() += "[]";\
	}\
	else\
	{\
		colTypes_.back() += tmp + 2;\
	};\
	tmp1 = TOSTRING(BOOST_PP_TUPLE_ELEM(2, 1, elem)); \
	colNames_.push_back(tmp1);\

#define TOSTRING(x)  STRINGIFY(x)

#define FUNCTOR_GET()

#define DEFINE_STRUCT_I(name, fields)        \
    class name                               \
    {								         \
		BOOST_PP_SEQ_FOR_EACH_I              \
            (DEFINE_STRUCT_FIELD, _, fields) \
	public:									 \
		name()                               \
		:			 					   	 \
		BOOST_PP_SEQ_FOR_EACH_I              \
           (INITMEMB,, fields)				 \
		BOOST_PP_SEQ_FOR_EACH_I              \
           (CONS, get, fields)				 \
		BOOST_PP_SEQ_FOR_EACH_I              \
           (CONS, set, fields)				 \
			last(false)						 \
		{}								     \
		bool last;					     	 \
	public:									 \
		BOOST_PP_SEQ_FOR_EACH_I              \
           (MACRO, get, fields)              \
		BOOST_PP_SEQ_FOR_EACH_I              \
           (MACRO, set, fields)              \
	template <class T, int> friend struct boost::fusion::extension::struct_member;\
    };                                       \
    BOOST_FUSION_ADAPT_STRUCT_I_PTR(name, fields)\
	struct name##_table : public table_container<name>\
	{\
		typedef std::vector<std::string> StrVec; \
		StrVec colTypes_;  \
		StrVec colNames_;  \
		name##_table()                      \
		{									\
		char *tmp =NULL;					\
		char *tmp1 =NULL;					\
		BOOST_PP_SEQ_FOR_EACH_I             \
           (INSERTTYPE, set, fields)        \
		}								    \
		typedef name row_type;\
	};



#define DEFINE_STRUCT_FIELD(r, _, i, xy)     \
    BOOST_PP_TUPLE_ELEM(2, 0, xy)            \
        *BOOST_PP_TUPLE_ELEM(2, 1, xy);

#define BOOST_FUSION_ADAPT_STRUCT_I_PTR(name, seq)                              \
    namespace boost { namespace fusion { namespace traits                       \
    {                                                                           \
        template <>                                                             \
        struct tag_of<name>                                                     \
        {                                                                       \
            typedef struct_tag type;                                            \
        };                                                                      \
    }}}                                                                         \
    namespace boost { namespace fusion { namespace extension                    \
    {                                                                           \
        template <>                                                             \
        struct struct_size<name> : mpl::int_<BOOST_PP_SEQ_SIZE(seq)> {};        \
        BOOST_PP_SEQ_FOR_EACH_I(BOOST_FUSION_ADAPT_STRUCT_C_PTR, name, seq)     \
    }}}                                                                         \
    /***/

#define BOOST_FUSION_ADAPT_STRUCT_C_PTR(r, name, i, xy)                         \
    template <>                                                                 \
    struct struct_member<name, i>                                               \
    {                                                                           \
        typedef BOOST_PP_TUPLE_ELEM(2, 0, xy)* type;                            \
        static type& call(name& struct_)                                        \
        {                                                                       \
            return struct_.BOOST_PP_TUPLE_ELEM(2, 1, xy);                       \
        };                                                                      \
    };                                                                          \

	//Object factory
struct ObjectFactory
{
	template <class T>
	static T *newObj() { return new T; }
	
	template <class T>
	static T *newObj(size_t len) { return new T[len]; }

	template <>
	static int *newObj<int>() { return new int; }

	template <>
	static double *newObj<double>() { return new double; }
};

template <class T>
struct fuctor_set
{
};
template <class T>
struct fuctor_get
{
};
/*template <class T>
struct fuctor_set<T**>
{
};
template <class T>
struct fuctor_get<T**>
{
};*/

//functor set, used in table definition
template <class T>
struct fuctor_set<T*>
{
	typedef T type;
	fuctor_set(T *&t)
		: m_t(t)
	{ 
		m_t = ObjectFactory::newObj<T>();
	}
	void set_null() {
		if (m_t)
			delete m_t;
		m_t = NULL; 
	}
	void operator()(const T &t)
	{
		if (!m_t)
		{
			m_t = ObjectFactory::newObj<T>();
		}
		*m_t = t;
	}
	~fuctor_set() 
	{
		set_null();
	}
	T *&m_t;
};
//functor set, used in table definition
template <class T>
struct fuctor_get<T*>
{
	typedef T type;
	fuctor_get(T* &t)
		: m_t(t)
	{
	}
	bool isNull() const { return m_t == NULL; }
	T &operator()() const
	{
		if (!(m_t))
			throw std::runtime_error("empty element");
		return (T&)(*m_t);
	}
	 T *&m_t;
};


//Object allocator
struct ObjAllocator
{
    template <class T>
    void operator()(T *&val) const
    {
		val = ObjectFactory::newObj<T>();
    }
};
//User defined table caontainer will inhiret from this 
template<class T>
struct table_container
{
	typedef std::vector<boost::shared_ptr<T> > TInternalContainer;
	typedef typename TInternalContainer::iterator internal_iterator;
	typedef typename TInternalContainer::iterator iterator;
private:
	TInternalContainer cnt_;
public:
	iterator begin() { return cnt_.begin(); }
	iterator end() { return cnt_.end(); }
	internal_iterator begin_internal() { return cnt_.begin(); }
	internal_iterator end_internal() { return cnt_.end(); }

	T &back() { return *cnt_.back().get(); }
	
public:
	void push_back(boost::shared_ptr<T> t)
	{
		cnt_.push_back(t);
	}
	void erase(const iterator &i)
	{
		v.erase(i);
	}
	size_t size() const
	{
		return cnt_.size();
	}
	void clear()
	{
		return cnt_.clear();
	}
};
/*
class JoinResults
{
	std::multimap<const int, const int> m_;

	struct Iterator
	{
		typedef std::vector<boost::shared_ptr<T> > TInternalContainer;
		typedef typename TInternalContainer::iterator iterator;

		iterator start, end;

		Iterator(JoinResults &t)
		{
			start = t.m_.begin();
			end = t.m_.end();
		}
		T& getElement() { return *(*start).get(); }
		bool hasMoreElements() { return start != end; }
		void getNext() {++start; }
	};
	class Iterator
	{
		
	};
	Iterator begin() { return m.begin(); } 
	Iterator end() { return m.begin(); } 

	void addRelation(const int from, const int to)
	{
		m.insert(pair<const int, const int>(from, to));
	}
		
};*/