#pragma once

#include "stdafx.h"
#include "net_test_.h"
// used for helper cppunit macros
#include <cppunit/extensions/HelperMacros.h>
#include "ConnectionManager.h"
#include "CDBExecutor.h"

class SimpleTests : public CPPUNIT_NS::TestFixture
{
	
	CPPUNIT_TEST_SUITE( SimpleTests );

	CPPUNIT_TEST_SUITE_PROPERTY("schema", "home_nshevchenko");
	CPPUNIT_TEST_SUITE_PROPERTY("tableName", "inst_2");
	CPPUNIT_TEST_SUITE_PROPERTY( PGint8ArrParamInProcedure );
	CPPUNIT_TEST( CDBExecutorArrayParamInProcedure );
	CPPUNIT_TEST( CDBExecutorSelectTest );
	CPPUNIT_TEST( CDBExecutorSelectPrepared );
	CPPUNIT_TEST( CDBExecutorInsertTest );
	CPPUNIT_TEST( CDBExecutorInsertPrepared );
	CPPUNIT_TEST( CDBExecutorProcedureCall );
	
	CPPUNIT_TEST_SUITE_END();

protected:
	ConnectionInfo connInfo_;
	boost::shared_ptr<ConnectionManager> conn_;

	bool firstTimeSetUp_;
	typedef boost::shared_ptr<Inst::inst_> TSmart_table;
	TSmart_table test_tbl;
	boost::shared_ptr<CDBExecutor<Inst::inst_> > dbNetTest_;

public:
	SimpleTests() : dbNetTest_() {};
	void setUp();
	void tearDown();

protected:
	void CDBExecutorSelectTest();
	void CDBExecutorSelectPrepared();
	void CDBExecutorInsertTest();
	void CDBExecutorInsertPrepared();
	void CDBExecutorProcedureCall();
	void CDBExecutorArrayParamInProcedure();
	void CDBExecutorPGint8ArrParamInProcedure();
};

