#pragma once

#include <windows.h>
#include <sstream>
#include <iomanip>

#include "ATLComTime.h"


class WindowsTimeReporter
{
public:
		static std::string NowTime();
};

inline std::string WindowsTimeReporter :: NowTime()
{
	const int MAX_LEN = 200;
	char buffer[MAX_LEN];
	if (GetTimeFormatA(LOCALE_USER_DEFAULT, 0, 0, 
			"HH':'mm':'ss", buffer, MAX_LEN) == 0)
		return "GetTimeFormatA failed";

	std::stringstream ss;
	SYSTEMTIME SystemTime;
	GetSystemTime(&SystemTime);

	ss << buffer << "." << std::setw(3) << std::setfill('0')<< SystemTime.wMilliseconds;
	return ss.str();
}
